const gulp = require('gulp'),
  config = require('./tools/buildConfig'),
  smartJS = require('./task/smartjs'),
  smartCss = require('./task/smartcss');

config.prepare();
smartJS.prepare(config);
smartCss.prepare(config);

gulp.task('watchMe', () => {
  smartJS.startWatch();
  smartCss.startWatch();
});

gulp.task('default', gulp.parallel([...smartJS.build(), ...smartCss.build()]));

gulp.task('watch', gulp.parallel(['watchMe', ...smartJS.build(), ...smartCss.build()]));
